package com.mortals.xhx.busiz.web;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.mortals.framework.annotation.UnAuth;
import com.mortals.framework.service.ILogService;
import com.mortals.framework.service.impl.FileLogServiceImpl;
import com.mortals.xhx.base.system.message.MessageService;
import lombok.extern.slf4j.Slf4j;
import okhttp3.*;
import okio.BufferedSource;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.reactive.function.client.WebClient;
import org.springframework.web.servlet.mvc.method.annotation.SseEmitter;
import reactor.core.publisher.Flux;

import java.io.IOException;
import java.time.Duration;
import java.util.Collections;
import java.util.concurrent.TimeUnit;

@RestController
@Slf4j
@RequestMapping("api")
public class ApiSendMsgController {
    @Autowired
    protected ILogService logService = FileLogServiceImpl.getInstance();
    @Autowired
    private MessageService messageService;

    @GetMapping(value = "/events", produces = MediaType.TEXT_EVENT_STREAM_VALUE)
    public Flux<String> streamEvents() {
        return Flux.interval(Duration.ofSeconds(1))
                .map(i -> "Event " + i);
    }

    @GetMapping("/emitter")
    @UnAuth
    public SseEmitter test() throws IOException, InterruptedException {
        // filters.forEach(filter -> System.out.println("Loaded filter: " + filter.getClass().getName()));
        //每3s向前端推送消息
        SseEmitter emitter = new SseEmitter(30000L);
        for (int i = 0; i < 50; i++) {
            log.info("num:{}", i);
            emitter.send("后端推送信息" + i);

            Thread.sleep(1000);
        }
        emitter.complete();
        return emitter;
    }

   /* *//**
     * 接收机器人请求数据
     *
     * @param req
     * @return
     *//*
    @PostMapping(value = "trans", produces = MediaType.TEXT_EVENT_STREAM_VALUE)
    @UnAuth
    public SseEmitter trans(@RequestBody RobotTransReq req) {
        log.info("【接收机器人请求数据】【请求体】-->  " + JSONObject.toJSONString(req));

        //todo 业务处理 转发请求

        RobotTransResp rsp = new RobotTransResp();
        // 超时时间设置为30s，
        SseEmitter sseEmitter = new SseEmitter(30000L);
        messageService.sendMessageToFastApi(sseEmitter, req);
        return sseEmitter;

        //  return messageService.sendMessageToFastApi(sseEmitter, req);


        // 设置前端的重试时间为1s
*//*        sseEmitter.send(SseEmitter.event().reconnectTime(1000).data("连接成功"));
        sseCache.put(id, sseEmitter);
        System.out.println("add " + id);
        sseEmitter.onTimeout(() -> {
            System.out.println(id + "超时");
            sseCache.remove(id);
        });
        sseEmitter.onCompletion(() -> System.out.println("完成！！！"));*//*


        //  log.info("响应【接收机器人请求数据】【响应体】-->  " + JSONObject.toJSONString(rsp));
        //  return JSON.toJSONString(rsp);
    }
*/

    public static void main(String[] args) {

        OkHttpClient client = new OkHttpClient.Builder()
                .connectTimeout(30, TimeUnit.SECONDS)
                .readTimeout(30, TimeUnit.SECONDS)
                .writeTimeout(30, TimeUnit.SECONDS)
                .build();

        // 封装请求头
        Headers headers = new Headers.Builder()
                .set("Content-Type", "application/json")
                .set("Accept", "text/event-stream")
                .build();

        Request request = new Request.Builder()
                .url("http://localhost:18006/api/emitter")
                .headers(headers)
                .get()
                .build();


        Call call = client.newCall(request);


        // 4. 监听回调
        call.enqueue(new Callback() {
            @Override
            public void onFailure(Call call, IOException e) {
                log.error("进入 onFailure方法 {}", e.getMessage(), e);
                // sseEmitter.completeWithError(e);
            }

            @Override
            public void onResponse(Call call, Response response) throws IOException {
                if (response.isSuccessful()) {
                    String chunkMessage = "";
                    BufferedSource source = response.body().source();
                    while (!source.exhausted()) {
                        chunkMessage = source.readUtf8Line();
                        if (StringUtils.isBlank(chunkMessage)) {
                            continue;
                        }
                       /* JSONObject jsonObject = JSONObject.parseObject(chunkMessage);
                        if (null != jsonObject && null != jsonObject.getJSONObject("data")) {
                            String answer = jsonObject.getJSONObject("data").getString("answer");
                            //   sseEmitter.send(answer);
                        }*/

                        log.info("chunkMessage:{}", chunkMessage);

                    }

                } else {
                    // log.error("onResponse 方法请求失败 {}", response.message());
                    // TODO 重新发起请求
                }
            }
        });


        log.info("22222222222222222");

        SseEmitter sseEmitter = new SseEmitter(30000L);

        WebClient webClient = WebClient.builder().baseUrl("http://localhost:18006").build();


     /*   // 封装请求头
        HttpHeaders headers = new HttpHeaders();
        headers.setContentType(MediaType.APPLICATION_JSON);
        //headers.set(authHead, authValue);

        // headers.setBasicAuth("Authorization","fastgpt-jZqZqjWQOic82RbTFdzAu94ddX0YL0ZWfBUtYAcVtewIkXe0yUfH");
        // accept 一定要设置为 TEXT_EVENT_STREAM
        headers.setAccept(Collections.singletonList(MediaType.TEXT_EVENT_STREAM));

        Flux<String> eventStream = webClient
                .get()
                .uri("/api/emitter")
                .accept(MediaType.valueOf("text/event-stream;charset=UTF-8")) // 一定要设置
                .retrieve()
                .bodyToFlux(String.class);
        // eventStream.flatMap(data -> {}).collect()

        eventStream.subscribe(
                data -> { // data 有什么key，value。具体看你对接agent的文档
                    log.info("data:{}", data);

                },
                error -> {
                    sseEmitter.completeWithError(error);
                    log.error("报错了:{}", error.getMessage(), error);
                },
                sseEmitter::complete
        );*/
    }


}
